]> pd.if.org Git - zpackage/blobdiff - t/tap.sh
add -o option to runscript
[zpackage] / t / tap.sh
index b82f203f5f7628cbdaca6d46d46974a2431ba826..580fcbd2d02d6be9e0627a880af59dee46bd6ad8 100755 (executable)
--- a/t/tap.sh
+++ b/t/tap.sh
@@ -7,7 +7,7 @@ tryrun() {
        note="$@"
        program=$1
        shift
-       $program "$@"
+       $program "$@" >> test.out 2>&1
        if [ $? -ne 0 ]; then
                printf 'not ';
        fi
@@ -16,19 +16,26 @@ tryrun() {
 }
 
 require() {
-       note="$@"
+       note="$*"
        program=$1
        shift
-       $program "$@"
-       if [ $? -ne 0 ]; then
-               printf "bail out! fail[$?]: $@\n"
-               exit 255;
-       fi
+       $program "$@" >> test.out 2>&1
+       rv=$?
        tn=$((tn + 1))
+       if [ $rv -ne 0 ]; then
+               printf 'not ok %d - %s %s\n' $tn $program "$*"
+               bailout "exit status $rv";
+       fi
        printf 'ok %d - %s %s\n' $tn $program "$*"
 
 }
 
+bailout() {
+       diag "$@"
+       printf "bail out!\n";
+       exit 255;
+}
+
 shownote() {
        if [ "$note" != "" ]; then
                printf '# %s\n' "$note"
@@ -39,6 +46,14 @@ diag() {
        printf '# %s\n' "$@"
 }
 
+diagfile() {
+       sed -e 's/^/# /' $1
+}
+
+diagstdin() {
+       sed -e 's/^/# /'
+}
+
 okexit() {
        exitwith 0 "$*"
 }